function [U, RelE]=Master1DmDiff(casenr,dx,t_end,visc,methnr,CFL)
x=[0:dx:10];
kappa=1.5;
alpha=3
l=alpha+2
gamma=l/alpha
if gamma<=1
    return
end

switch casenr
    case {1}
        U(:,1) = 1+(1 + sin((2*x-pi/2))).*(x<=2*pi).*(x>=pi);
    case {2}
        U(:,1) = 1+ 1*ones(size(x)).*(abs(x)<=6).*(abs(x)>=4);
    case {3}
        U(:,1) = 1+0.3*sin(x);
    case {4}
        U(:,1) = 0.6+ 0.2*heaviside(x-4);
    case {5}
        U(:,1) = 1+ 1*heaviside(4-x);
end
U(:,2)=zeros(size(x));
Up=U;
E0=0.5*U(:,2).^2./U(:,1)+kappa*U(:,1).^gamma/(gamma-1);
E0S=abs(sum(E0));
RelE=[0 0];
t=0;
CFL;
N=size(U(:,1))
while t<t_end    
    dt =CFL*dx/max(mdf(U,kappa,gamma)); %tempdt
    Up(1,1)=(U(2,1));
    Up(end,1)=(U(end-1,1));
    Up(1,2)=(U(2,2));
    Up(end,2)=(U(end-1,2));

    switch methnr
        case {1}
            Fl=roes(U,dt,dx,visc,kappa,gamma,l,alpha);
            Up(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*Fl(1:end,1);
            Up(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*Fl(1:end,2);
        case {2}
            Fl=locallaxfriedrich(U,kappa,gamma,dt,dx);
            Up(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*Fl(:,1);
            Up(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*Fl(:,2);   
        case {3}
            Fl=fluxm(U,dt,dx,visc,kappa,gamma,l,alpha);
            Up(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*Fl(1:end,1);
            Up(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*Fl(1:end,2);
        case {4}
            Fl=laxfriedrich(U,kappa,gamma,dt,dx,visc);
            Up(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*Fl(:,1);
            Up(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*Fl(:,2);  
        case {5}
            Fl=fluxm(U,dt,dx,visc,kappa,gamma,l,alpha);
            Upt=Up;
            Upt(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*Fl(1:end,1);
            Upt(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*Fl(1:end,2);
            Fl2=fluxm(Upt,dt,dx,visc,kappa,gamma,l,alpha);
            Up(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*(0.5*(Fl(1:end,1)+Fl2(1:end,1)));
            Up(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*(0.5*(Fl(1:end,2)+Fl2(1:end,2)));
        case {6}
            Fl=locallaxfriedrich(U,kappa,gamma,dt,dx);
            Upt=Up;
            Upt(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*Fl(1:end,1);
            Upt(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*Fl(1:end,2);
            Fl2=locallaxfriedrich(Upt,kappa,gamma,dt,dx);          
            Up(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*(0.5*(Fl(1:end,1)+Fl2(1:end,1)));
            Up(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*(0.5*(Fl(1:end,2)+Fl2(1:end,2)));
        case {7}
            Fl=roes2(U,visc,kappa,gamma);
            Upt=Up;
            Upt(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*Fl(1:end,1);
            Upt(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*Fl(1:end,2);
            Fl2=roes2(Upt,visc,kappa,gamma);          
            Up(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*(0.5*(Fl(1:end,1)+Fl2(1:end,1)));
            Up(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*(0.5*(Fl(1:end,2)+Fl2(1:end,2)));
            
    end
    U=Up;
    lowerH=0.1;
    L=length(U(:,1));
    for i=2:L-1
        if U(i,1)<lowerH
            U(i,2)=0;
        end
    end        
    %plot(x,U,'-');
    %axis([-2 16 -2 5]);
    %shg
    %drawnow;
    E1=0.5*U(:,2).^2./U(:,1)+kappa*U(:,1).^gamma/(gamma-1);
    ED=abs(sum(E1-E0));
    RelE(end+1,:)=[ED/E0S t+dt];
    
    t=t+dt;
end
%axis([-2 16 -2 2]);
%shg
plot(x,U(:,1),'-');
end

function ret1 = roes(u,dt,dx,visc,kappa,gamma,l,alpha)
rho0=u(1:end-1,1);
rho1=u(2:end,1);
m0=u(1:end-1,2);
m1=u(2:end,2);

Vhopp=v2(rho1,m1,kappa,gamma)-v2(rho0,m0,kappa,gamma);
Vhopp=Vhopp.';
R(1,1,:)=ones(size(rho0));
R(1,2,:)=ones(size(rho0));
R(2,1,:)=(rho0.^(0.5).*w2(rho0,m0)+rho1.^(0.5).*w2(rho1,m1))./(rho0.^(0.5)+rho1.^(0.5))-(gamma*kappa*0.5.*(rho0.^(gamma-1)+rho1(:,1).^(gamma-1))).^0.5;
R(2,2,:)=(rho0.^(0.5).*w2(rho0,m0)+rho1.^(0.5).*w2(rho1,m1))./(rho0.^(0.5)+rho1.^(0.5))+(gamma*kappa*0.5.*(rho0.^(gamma-1)+rho1(:,1).^(gamma-1))).^0.5;

RT(1,1,:)=ones(size(rho0));
RT(1,2,:)=(rho0.^(0.5).*w2(rho0,m0)+rho1.^(0.5).*w2(rho1,m1))./(rho0.^(0.5)+rho1.^(0.5))-(gamma*kappa*0.5.*(rho0.^(gamma-1)+rho1.^(gamma-1))).^0.5;
RT(2,1,:)=ones(size(rho0));
RT(2,2,:)=(rho0.^(0.5).*w2(rho0,m0)+rho1.^(0.5).*w2(rho1,m1))./(rho0.^(0.5)+rho1.^(0.5))+(gamma*kappa*0.5.*(rho0.^(gamma-1)+rho1.^(gamma-1))).^0.5;

for i=1:size(rho0)
R(1:2,1:2,i)=R(1:2,1:2,i).*(0.5.*(rho0(i,1)+rho1(i,1))/(2*kappa*gamma)).^0.5;
RT(1:2,1:2,i)=RT(1:2,1:2,i).*(0.5.*(rho0(i,1)+rho1(i,1))/(2*kappa*gamma)).^0.5;
end

LambdaC(1,1,:)=abs((rho0.^(0.5).*w2(rho0,m0)+rho1.^(0.5).*w2(rho1,m1))./(rho0.^(0.5)+rho1.^(0.5))-(gamma*kappa*0.5.*(rho0.^(gamma-1)+rho1(:,1).^(gamma-1))).^0.5);
LambdaC(1,2,:)=zeros(size(rho0));
LambdaC(2,1,:)=zeros(size(rho0));
LambdaC(2,2,:)=abs((rho0.^(0.5).*w2(rho0,m0)+rho1.^(0.5).*w2(rho1,m1))./(rho0.^(0.5)+rho1.^(0.5))+(gamma*kappa*0.5.*(rho0.^(gamma-1)+rho1(:,1).^(gamma-1))).^0.5);

for i=1:size(rho0)
    Matr(:,i)=visc/2*(R(:,:,i)*LambdaC(:,:,i)*RT(:,:,i))*Vhopp(:,i);
end
Matr=Matr.';
	c = mdf(u,kappa,gamma);
	D = max(c(1:end-1), c(2:end));
	D = [D, D];
Diffu2=D/2.*([rho1 m1] - [rho0 m0]);
favg=0.5*(f([rho1 m1],kappa,gamma) + f([rho0 m0],kappa,gamma));
ret1(:,1)=favg(:,1)-Matr(:,1);%-visc*dx/(2*dt).*(rho1-rho0);%%-visc.*(u(2:(end),1)-u(1:(end-1),1))%-visc.*D/(2).*Vhopp(:,1)%-visc*dx/(2*dt).*(u1(:,1)-u0(:,1));
ret1(:,2)=favg(:,2)-Matr(:,2);%-visc*dx/(2*dt).*(m1-m0);%-visc.*(u(2:(end),2)-u(1:(end-1),2))%-visc*D/(2).*Vhopp(:,2)%-visc*dx/(2*dt).*(u1(:,2)-u0(:,2));
ret1=diff(ret1);
end

function ret1 = roes2(u,visc,kappa,gamma)
rho0=u(1:end-1,1);
rho1=u(2:end,1);
m0=u(1:end-1,2);
m1=u(2:end,2);

Vhopp=v2(rho1,m1,kappa,gamma)-v2(rho0,m0,kappa,gamma);
ups=(gamma*kappa*0.5.*(rho0.^(gamma-1)+rho1(:,1).^(gamma-1))).^0.5;
wf=0.5*(w2(rho0,m0)+w2(rho1,m1));
a=wf-ups;
b=wf+ups;
matrcoeff=(0.5.*(rho0(:,1).^(2-gamma)+rho1(:,1).^(2-gamma))/(2*kappa*gamma));
matrjump(1,:)=visc/2*matrcoeff.*((abs(a)+abs(b)).*Vhopp(:,1)+(abs(a).*a+abs(b).*b).*Vhopp(:,2));
matrjump(2,:)=visc/2*matrcoeff.*((abs(a).*a+abs(b).*b).*Vhopp(:,1)+(abs(a).*a.^2+abs(b).*b.^2).*Vhopp(:,2));
matrjump=matrjump';

%	c = mdf(u,kappa,gamma);
%	D = max(c(1:end-1), c(2:end));
%	D = [D, D];
%Diffu2=D/2.*([rho1 m1] - [rho0 m0]);
favg=0.5*(f([rho1 m1],kappa,gamma) + f([rho0 m0],kappa,gamma));
ret1(:,1)=favg(:,1)-matrjump(:,1);%-visc*dx/(2*dt).*(rho1-rho0);%%-visc.*(u(2:(end),1)-u(1:(end-1),1))%-visc.*D/(2).*Vhopp(:,1)%-visc*dx/(2*dt).*(u1(:,1)-u0(:,1));
ret1(:,2)=favg(:,2)-matrjump(:,2);%-visc*dx/(2*dt).*(m1-m0);%-visc.*(u(2:(end),2)-u(1:(end-1),2))%-visc*D/(2).*Vhopp(:,2)%-visc*dx/(2*dt).*(u1(:,2)-u0(:,2));
ret1=diff(ret1);
end

function ret1 = fluxm(u,dt,dx,visc,kappa,gamma,l,alpha)
rho0=u(1:end-1,1);
rho1=u(2:end,1);
m0=u(1:end-1,2);
m1=u(2:end,2);
first=(rho0.^(1/alpha)+rho1.^(1/alpha));
if l-1>=2
    for i=2:l-1
        first=first.*avg(rho0.^(1/alpha),rho1.^(1/alpha))+avg(rho0.^(i/alpha),rho1.^(i/alpha));
    end
end
second=(rho0.^(1/alpha)+rho1.^(1/alpha));

Vhopp=v2(rho1,m1,kappa,gamma)-v2(rho0,m0,kappa,gamma);
ups=(gamma*kappa*0.5.*(rho0.^(gamma-1)+rho1(:,1).^(gamma-1))).^0.5;
wf=0.5*(w2(rho0,m0)+w2(rho1,m1));
a=wf-ups;
b=wf+ups;
matrcoeff=(0.5.*(rho0(:,1).^(2-gamma)+rho1(:,1).^(2-gamma))/(2*kappa*gamma));
matrjump(1,:)=visc/2*matrcoeff.*((abs(a)+abs(b)).*Vhopp(:,1)+(abs(a).*a+abs(b).*b).*Vhopp(:,2));
matrjump(2,:)=visc/2*matrcoeff.*((abs(a).*a+abs(b).*b).*Vhopp(:,1)+(abs(a).*a.^2+abs(b).*b.^2).*Vhopp(:,2));
matrjump=matrjump';
%	c = mdf(u,kappa,gamma);
%	D = max(c(1:end-1), c(2:end));
%	D = [D, D];
%Diffu2=D/2.*([rho1 m1] - [rho0 m0]);

ret1(:,1)=((gamma-1).*first./(gamma*second))*0.5.*(w2(rho0,m0)+w2(rho1,m1))-matrjump(:,1);%-Matr(:,1);%-visc*dx/(2*dt).*(rho1-rho0);%%-visc.*(u(2:(end),1)-u(1:(end-1),1))%-visc.*D/(2).*Vhopp(:,1)%-visc*dx/(2*dt).*(u1(:,1)-u0(:,1));
ret1(:,2)=((gamma-1).*first./(gamma*second)).*(0.5*(w2(rho0,m0)+w2(rho1,m1))).^2+kappa.*(0.5*(rho0.^gamma+rho1.^gamma))-matrjump(:,2);%-Matr(:,2);%-visc*dx/(2*dt).*(m1-m0);%-visc.*(u(2:(end),2)-u(1:(end-1),2))%-visc*D/(2).*Vhopp(:,2)%-visc*dx/(2*dt).*(u1(:,2)-u0(:,2));
ret1=diff(ret1);
end
 
function ret2 = f(u,kappa,gamma)
ret2(:,1) = u(:,2);
ret2(:,2) = u(:,2).^2./u(:,1)+kappa*u(:,1).^gamma;
end

function ret= v(u,kappa,gamma)
ret(:,1)=kappa*gamma/(gamma-1).*u(:,1).^(gamma-1)-0.5.*w(u).^2;
ret(:,2)=w(u);
end

function ret= v2(rho,m,kappa,gamma)
ret(:,1)=kappa*gamma/(gamma-1).*rho.^(gamma-1)-0.5.*w2(rho,m).^2;
ret(:,2)=w2(rho,m);
end

function ret2b = locallaxfriedrich(u,kappa,gamma,dt,dx)
	c = mdf(u,kappa,gamma);
	D = max(c(1:end-1), c(2:end));
	D = [D, D];
	F = (f(u(2:end,:),kappa,gamma) + f(u(1:end-1,:),kappa,gamma))/2 - D/2.*(u(2:end,:) - u(1:end-1,:));
	ret2b = diff(F,1);
end

function ret2c = laxfriedrich(u,kappa,gamma,dt,dx,visc)
F1=(f(u(2:end-1,:),kappa,gamma)+f(u(1:end-2,:),kappa,gamma))/2-visc*dx/(2*dt)*(u(2:end-1,:)-u(1:end-2,:));
F2=(f(u(3:end,:),kappa,gamma)+f(u(2:end-1,:),kappa,gamma))/2-visc*dx/(2*dt)*(u(3:end,:)-u(2:end-1,:));
F=F2-F1;
ret2c(:,1) = F(:,1);
ret2c(:,2) = F(:,2);
end

function ret3 = mdf(u,kappa,gamma)
%ret3(:,1) = abs(w(u))+sqrt(g*u(:,1));
% sq=sqrt(gamma*kappa*u(:,1).^(gamma-1));
% vel1=max(abs(w(u)+sq));
% vel2=max(abs(w(u)-sq));
% ret3=max(vel1,vel2);
ret3 = abs(u(:,2)./u(:,1)) + sqrt(u(:,1));
end

function ret4 = w(u)
ret4=u(:,2)./u(:,1);
end

function ret4 = w2(rho,m)
ret4=m./rho;
end

function ret=avg(u0,u1)
ret=(u0+u1)/2;
end

