function [U RelE]=Master1DuDiff(casenr,dx,t_end,visc,methnr,CFL)
x=[0:dx:10];
kappa=1.5;
alpha=3;
l=alpha+2;
gamma=l/alpha;
if gamma<=1
    return
end

switch casenr
    case {1}
        U(:,1) = 1+(1 + sin((2*x-pi/2))).*(x<=2*pi).*(x>=pi);
    case {2}
        U(:,1) = 1+ 1*ones(size(x)).*(abs(x)<=6).*(abs(x)>=4);
    case {3}
        U(:,1) = 1+0.3*sin(x);
    case {4}
        U(:,1) = 0.6+ 0.2*heaviside(x-4);
    case {5}
        U(:,1) = 1+ 1*heaviside(4-x);
end
U(:,2)=zeros(size(x));
Up=U;
t=0;
E0=0.5*U(:,2).^2./U(:,1)+kappa*U(:,1).^gamma/(gamma-1);
E0S=abs(sum(E0));
RelE=[0 0];
%CFL=0.01;
N=size(U(:,1))
while t<t_end    
    dt=CFL*dx/max(mdf(U,kappa,gamma)); %tempdt
    Up(1,1)=(U(2,1));
    Up(end,1)=(U(end-1,1));
    Up(1,2)=(U(2,2));
    Up(end,2)=(U(end-1,2));

    switch methnr
        case {1}
            %Fl=flu(U,dt,dx,visc,kappa,gamma,l,alpha);
            Fl=favgf(U,kappa,gamma);
            Upt=Up;
            Upt(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*Fl(1:end,1);
            Upt(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*Fl(1:end,2);
            %Fl2=flu(Upt,dt,dx,visc,kappa,gamma,l,alpha);
            Fl2=favgf(Upt,kappa,gamma);            
            Up(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*(0.5*(Fl(1:end,1)+Fl2(1:end,1)));
            Up(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*(0.5*(Fl(1:end,2)+Fl2(1:end,2)));
        case {2}
            Fl=fluxm(U,kappa,gamma,l,alpha);
            %Upt=Up;
            %Upt(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*Fl(1:end,1);
            %Upt(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*Fl(1:end,2);
            %Fl2=fluxm(Upt,dt,dx,visc,kappa,gamma,l,alpha);
            %Up(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*(0.5*(Fl(1:end,1)+Fl2(1:end,1)));
            %Up(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*(0.5*(Fl(1:end,2)+Fl2(1:end,2)));
            Up(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*Fl(1:end,1);
            Up(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*Fl(1:end,2);
        case {3}
            Fl=fluxm(U,kappa,gamma,l,alpha);
            Upt=Up;
            Upt(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*Fl(1:end,1);
            Upt(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*Fl(1:end,2);
            Fl2=fluxm(Upt,kappa,gamma,l,alpha);
            Up(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*(0.5*(Fl(1:end,1)+Fl2(1:end,1)));
            Up(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*(0.5*(Fl(1:end,2)+Fl2(1:end,2)));
        case {4}
            Fl=flu(U,dt,dx,visc,kappa,gamma,l,alpha);
            Up(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*Fl(1:end,1);
            Up(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*Fl(1:end,2);
        case {5}
            Fl=fluxMono(U,kappa);
            Upt=Up;
            Upt(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*Fl(1:end,1);
            Upt(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*Fl(1:end,2);
            Fl2=fluxMono(Upt,kappa);
            Up(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*(0.5*(Fl(1:end,1)+Fl2(1:end,1)));
            Up(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*(0.5*(Fl(1:end,2)+Fl2(1:end,2)));
    end
    U=Up;
    lowerH=0.1;
    L=length(U(:,1));
    for i=2:L-1
        if U(i,1)<lowerH
            U(i,2)=0;
        end
    end        
    %plot(x,U,'-');
    %axis([0 10 0 2]);
    %shg
    %drawnow;
    E1=0.5*U(:,2).^2./U(:,1)+kappa*U(:,1).^gamma/(gamma-1);
    ED=abs(sum(E1-E0));
    RelE(end+1,:)=[ED/E0S t+dt];
    t=t+dt;
end
%shg
plot(x,U(:,1),'-');
%figure
%plot(RelE(:,2),RelE(:,1),'-');
end

function ret1 = flu(u,dt,dx,visc,kappa,gamma,l,alpha)
rho0=u(1:end-1,1);
rho1=u(2:end,1);
m0=u(1:end-1,2);
m1=u(2:end,2);
favg=0.5*(f([rho1 m1],kappa,gamma) + f([rho0 m0],kappa,gamma));
ret1(:,1)=favg(:,1);%-visc*dx/(2*dt).*(rho1-rho0);%%-visc.*(u(2:(end),1)-u(1:(end-1),1))%-visc.*D/(2).*Vhopp(:,1)%-visc*dx/(2*dt).*(u1(:,1)-u0(:,1));
ret1(:,2)=favg(:,2);%-visc*dx/(2*dt).*(m1-m0);%-visc.*(u(2:(end),2)-u(1:(end-1),2))%-visc*D/(2).*Vhopp(:,2)%-visc*dx/(2*dt).*(u1(:,2)-u0(:,2));
ret1=diff(ret1);
end

function ret= favgf(u,kappa,gamma)
ret=0.5*(f([u(2:end,1) u(2:end,2)],kappa,gamma) + f([u(1:end-1,1) u(1:end-1,2)],kappa,gamma));
ret=diff(ret);
end
    
function ret1 = fluxm(u,kappa,gamma,l,alpha)
rho0=u(1:end-1,1);
rho1=u(2:end,1);
m0=u(1:end-1,2);
m1=u(2:end,2);
first=(rho0.^(1/alpha)+rho1.^(1/alpha));
if l-1>=2
    for i=2:l-1
        first=first.*avg(rho0.^(1/alpha),rho1.^(1/alpha))+avg(rho0.^(i/alpha),rho1.^(i/alpha));
    end
end
second=(rho0.^(1/alpha)+rho1.^(1/alpha));

%Vhopp=v2(rho1,m1,kappa,gamma)-v2(rho0,m0,kappa,gamma);
%Vhopp=Vhopp.';

ret1(:,1)=((gamma-1).*first./(gamma*second))*0.5.*(w2(rho0,m0)+w2(rho1,m1));%-visc*dx/(2*dt).*(rho1-rho0);%%-visc.*(u(2:(end),1)-u(1:(end-1),1))%-visc.*D/(2).*Vhopp(:,1)%-visc*dx/(2*dt).*(u1(:,1)-u0(:,1));
ret1(:,2)=((gamma-1).*first./(gamma*second)).*(0.5*(w2(rho0,m0)+w2(rho1,m1))).^2+kappa.*(0.5*(rho0.^gamma+rho1.^gamma));%-visc*dx/(2*dt).*(m1-m0);%-visc.*(u(2:(end),2)-u(1:(end-1),2))%-visc*D/(2).*Vhopp(:,2)%-visc*dx/(2*dt).*(u1(:,2)-u0(:,2));
ret1=diff(ret1);
end

    
function ret1 = fluxMono(u,kappa)
rho0=u(1:end-1,1);
rho1=u(2:end,1);
m0=u(1:end-1,2);
m1=u(2:end,2);
first=2*(0.5*(rho0.^(1/3)+rho1.^(1/3))).^4+(0.5*(rho0.^(2/3)+rho1.^(2/3))).*(0.5*(rho0.^(1/3)+rho1.^(1/3))).^2+(0.5*(rho0+rho1)).*(0.5*(rho0.^(1/3)+rho1.^(1/3)))+(0.5*(rho0.^(4/3)+rho1.^(4/3)));
second=(rho0.^(1/3)+rho1.^(1/3));
ret1(:,1)=(0.4.*first./second)*0.5.*(m0./rho0+m1./rho1);%-visc*dx/(2*dt).*(rho1-rho0);%%-visc.*(u(2:(end),1)-u(1:(end-1),1))%-visc.*D/(2).*Vhopp(:,1)%-visc*dx/(2*dt).*(u1(:,1)-u0(:,1));
ret1(:,2)=(0.4.*first./second).*(0.5*(m0./rho0+m1./rho1)).^2+kappa.*(0.5*(rho0.^(5/3)+rho1.^(5/3)));%-visc*dx/(2*dt).*(m1-m0);%-visc.*(u(2:(end),2)-u(1:(end-1),2))%-visc*D/(2).*Vhopp(:,2)%-visc*dx/(2*dt).*(u1(:,2)-u0(:,2));
ret1=diff(ret1);
end
 
function ret2 = f(u,kappa,gamma)
ret2(:,1) = u(:,2);
ret2(:,2) = u(:,2).^2./u(:,1)+kappa*u(:,1).^gamma;
end

function ret= v(u,kappa,gamma)
ret(:,1)=kappa*gamma/(gamma-1).*u(:,1).^(gamma-1)-0.5.*w(u).^2;
ret(:,2)=w(u);
end

function ret= v2(rho,m,kappa,gamma)
ret(:,1)=kappa*gamma/(gamma-1).*rho.^(gamma-1)-0.5.*w2(rho,m).^2;
ret(:,2)=w2(rho,m);
end

function ret3 = mdf(u,kappa,gamma)
%ret3(:,1) = abs(w(u))+sqrt(g*u(:,1));
 sq=sqrt(gamma*kappa*u(:,1).^(gamma-1));
 %vel1=max(abs(w(u)+sq));
 %vel2=max(abs(w(u)-sq));
 %ret3=max(vel1,vel2);
 ret3=max(max(abs(w(u)+sq)),max(abs(w(u)-sq)));
%ret3 = abs(u(:,2)./u(:,1)) + sqrt(u(:,1));
end

function ret4 = w(u)
ret4=u(:,2)./u(:,1);
end

function ret4 = w2(rho,m)
ret4=m./rho;
end

function ret=avg(u0,u1)
ret=(u0+u1)/2;
end

