function U=Master2DmDiff(casenr,dx,t_end,visc,methnr)
%x=[0:dx:10];
%y=[0:dx:10];
[x,y]=meshgrid(0:dx:10)
kappa=1.5;
alpha=3
l=alpha+2
gamma=l/alpha
if gamma<=1
    return
end

switch casenr
    case {1}
        U(:,:,1) = 1+(1 + sin((2*x-pi/2))).*(1 + sin((2*y-pi/2))).*(x<=2*pi).*(x>=pi).*(y<=2*pi).*(y>=pi);
    case {2}
        U(:,:,1) = 1+ 0.5*ones(size(x)).*ones(size(y)).*(abs(x)<=7).*(abs(x)>=3).*(abs(y)<=5.5).*(abs(y)>=4.5);
    case {3}
        U(:,1) = 1+0.3*sin(x);
    case {4}
        U(:,1) = 0.6+ 0.2*heaviside(x-4);
    case {5}
        U(:,1) = 1+ 1*heaviside(4-x);
end

U(:,:,2)=-0.2*ones(size(x));
U(:,:,3)=zeros(size(x));
size(U)
Up=U;
t=0;
CFL=0.5;
N=size(U(:,1))
while t<t_end    
    dt =CFL*dx/max(mdf(U,kappa,gamma)); %tempdt
    %Corners
    axis([0 10 0 10 -2 5]);
    surf(x,y,U(:,:,1))
    shg
    drawnow;
    %pause(1/10)
    
    Up(1,1,:)=(U(2,2,:));
    Up(end,end,:)=(U(end-1,end-1,:));
    Up(1,end,:)=(U(2,end-1,:));
    Up(end,1,:)=(U(end-1,2,:));
    %Sides
    
    Up(1,2:end-1,1)=0.5*(U(2,2:end-1,1)+U(3,2:end-1,1));
    Up(1,2:end-1,2)=-0.5*(U(2,2:end-1,2)+U(3,2:end-1,2));    
    Up(1,2:end-1,3)=0.5*(U(2,2:end-1,3))+U(3,2:end-1,3);
    
    Up(end,2:end-1,:)=0.5*(U(end-1,2:end-1,:)+U(end-2,2:end-1,:));
    Up(2:end-1,end,:)=0.5*(U(2:end-1,end-1,:)+U(2:end-1,end-2,:));
    Up(2:end-1,1,:)=0.5*(U(2:end-1,2,:)+U(2:end-1,3,:));

    switch methnr
        case {1}
            Fl=roesx(U,dt,dx,visc,kappa,gamma,l,alpha);
            Gl=roesy(U,dt,dx,visc,kappa,gamma,l,alpha);
            Up(:,2:(end-1),:)=U(:,2:(end-1),:)-dt/(dx).*Gl(:,1:end,:);
            Up(2:(end-1),:,:)=Up(2:(end-1),:,:)-dt/(dx).*Fl(1:end,:,:);


        case {2}
            Fl=locallaxfriedrich(U,kappa,gamma,dt,dx);
            Up(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*Fl(:,1);
            Up(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*Fl(:,2);   
        case {3}
            [Fl, Gl]=fluxm(U,dt,dx,visc,kappa,gamma,l,alpha);
            Up(2:(end-1),:,:)=U(2:(end-1),:,:)-dt/(dx).*Fl(1:end,:,:);
            Up(:,2:(end-1),:)=Up(:,2:(end-1),:)-dt/(dx).*Gl(:,1:end,:);
        case {4}
            Fl=laxfriedrich(U,kappa,gamma,dt,dx,visc);
            Up(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*Fl(:,1);
            Up(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*Fl(:,2);   
    end
    U=Up;
    %lowerH=0.1;
    %L=length(U(:,:,1));
    %for i=2:L-1
    %    if U(i,1)<lowerH
    %        U(i,2)=0;
    %    end
    %end
    surf(x,y,U(:,:,1))
    %axis([-2 16 -2 5]);
    shg
    drawnow;
    t=t+dt;
end
%axis([-2 16 -2 2]);
%shg
%plot(x,U,'-');
surf(x,y,U(:,:,1))

end

function ret1 = roesx(u,dt,dx,visc,kappa,gamma,l,alpha)
u1(:,:,:)=u(1:end-1,:,:);
u0(:,:,:)=u(2:end,:,:);
favg=0.5*(f(u1,kappa,gamma) + f(u0,kappa,gamma));
ret1(:,:,1)=favg(:,:,1);%-Matr(:,1);%-visc*dx/(2*dt).*(rho1-rho0);%%-visc.*(u(2:(end),1)-u(1:(end-1),1))%-visc.*D/(2).*Vhopp(:,1)%-visc*dx/(2*dt).*(u1(:,1)-u0(:,1));
ret1(:,:,2)=favg(:,:,2);%-Matr(:,2);%-visc*dx/(2*dt).*(m1-m0);%-visc.*(u(2:(end),2)-u(1:(end-1),2))%-visc*D/(2).*Vhopp(:,2)%-visc*dx/(2*dt).*(u1(:,2)-u0(:,2));
ret1(:,:,3)=favg(:,:,3);
ret1=ret1(2:end,:,:)-ret1(1:end-1,:,:);
end

function ret1b = roesy(u,dt,dx,visc,kappa,gamma,l,alpha)
u1(:,:,:)=u(:,1:end-1,:);
u0(:,:,:)=u(:,2:end,:);
gavg=0.5*(g(u1,kappa,gamma) + g(u0,kappa,gamma));
ret1b(:,:,1)=gavg(:,:,1);%-Matr(:,1);%-visc*dx/(2*dt).*(rho1-rho0);%%-visc.*(u(2:(end),1)-u(1:(end-1),1))%-visc.*D/(2).*Vhopp(:,1)%-visc*dx/(2*dt).*(u1(:,1)-u0(:,1));
ret1b(:,:,2)=gavg(:,:,2);%-Matr(:,2);%-visc*dx/(2*dt).*(m1-m0);%-visc.*(u(2:(end),2)-u(1:(end-1),2))%-visc*D/(2).*Vhopp(:,2)%-visc*dx/(2*dt).*(u1(:,2)-u0(:,2));
ret1b(:,:,3)=gavg(:,:,3);
ret1b=ret1b(:,2:end,:)-ret1b(:,1:end-1,:);
end

function [ret1F ret1G] = fluxm(u,dt,dx,visc,kappa,gamma,lx,alpha)
u0x(:,:,:)=u(1:end-1,:,:);
u1x(:,:,:)=u(2:end,:,:);
u0y(:,:,:)=u(:,1:end-1,:);
u1y(:,:,:)=u(:,2:end,:);

firstx=(u1x(:,:,1).^(1/alpha)+u0x(:,:,1).^(1/alpha));
firsty=(u1y(:,:,1).^(1/alpha)+u0y(:,:,1).^(1/alpha));
if lx-1>=2
    for i=2:lx-1
        firstx=firstx.*avg(u0x(:,:,1).^(1/alpha),u1x(:,:,1).^(1/alpha))+avg(u0x(:,:,1).^(i/alpha),u1x(:,:,1).^(i/alpha));
        firsty=firsty.*avg(u0y(:,:,1).^(1/alpha),u1y(:,:,1).^(1/alpha))+avg(u0y(:,:,1).^(i/alpha),u1y(:,:,1).^(i/alpha));
    end
end
secondx=(u0x(:,:,1).^(1/alpha)+u1x(:,:,1).^(1/alpha));
secondy=(u0y(:,:,1).^(1/alpha)+u1y(:,:,1).^(1/alpha));
Vhoppx=v(u1x,kappa,gamma)-v(u0x,kappa,gamma);
Vhoppy=v(u1y,kappa,gamma)-v(u0y,kappa,gamma);
%Vhoppx=permute(Vhoppx,[2 1 3])
%size(Vhoppx)

upsx=(gamma*kappa*0.5.*(u0x(:,:,1).^(gamma-1)+u0x(:,:,1).^(gamma-1))).^0.5;
upsy=(gamma*kappa*0.5.*(u0y(:,:,1).^(gamma-1)+u0y(:,:,1).^(gamma-1))).^0.5;

wfx=0.5*(wx(u0x)+wx(u1x));
wgx=0.5*(wy(u0x)+wy(u1x));
wfy=0.5*(wx(u0y)+wx(u1y));
wgy=0.5*(wy(u0y)+wy(u1y));

ax=wfx-upsx;
bx=wfx;
cx=wfx+upsx;
lx=wgx;

absax=abs(ax);
absbx=abs(bx);
abscx=abs(cx);

nx=(2*upsx).^0.5;

ky=wgy-upsy;
ly=wgy;
my=wgy+upsy;
by=wfy;

absky=abs(ky);
absly=abs(ly);
absmy=abs(my);

ny=(2*upsy).^0.5;

%maxlaxx=max(absax,absbx,abscx)
%maxlaxy=max(absky,absly,absmy)

matrcoeffx=(0.5.*(u0x(:,:,1).^(2-gamma)+u1x(:,:,1).^(2-gamma))/(2*kappa*gamma));
matrcoeffy=(0.5.*(u0y(:,:,1).^(2-gamma)+u1y(:,:,1).^(2-gamma))/(2*kappa*gamma));
%No1=size(Vhoppx)
%No2=size(abs(ax))
%No3=size(abs(by))
%No4=size(ax)
%No5=size(by)
%No6=size(matrcoeffx)
matrjumpx(:,:,1)=visc/2*matrcoeffx.*((absax+abscx).*Vhoppx(:,:,1)+(absax.*ax+abscx.*cx).*Vhoppx(:,:,2)+(absax.*lx+abscx.*lx).*Vhoppx(:,:,3));
matrjumpx(:,:,2)=visc/2*matrcoeffx.*((absax.*ax+abscx.*cx).*Vhoppx(:,:,1)+(absax.*ax.^2+abscx.*cx.^2).*Vhoppx(:,:,2)+(absax.*lx.*ax+abscx.*lx.*cx).*Vhoppx(:,:,3));
matrjumpx(:,:,3)=visc/2*matrcoeffx.*((absax.*lx+abscx.*lx).*Vhoppx(:,:,1)+(absax.*lx.*ax+abscx.*lx.*cx).*Vhoppx(:,:,2)+(absax.*lx.^2+abscx.*lx.^2+absbx.*nx.^2).*Vhoppx(:,:,3));

%laxmatx(:,:,1)=visc/2*maxlaxx.*Vhoppx(:,:,1)
%laxmatx(:,:,2)=visc/2*maxlaxx.*Vhoppx(:,:,2)
%laxmatx(:,:,3)=visc/2*maxlaxx.*Vhoppx(:,:,3)
%laxmaty(:,:,1)=visc/2*maxlaxy.*Vhoppy(:,:,1)
%laxmaty(:,:,2)=visc/2*maxlaxy.*Vhoppy(:,:,2)
%laxmaty(:,:,3)=visc/2*maxlaxy.*Vhoppy(:,:,3)

matrjumpy(:,:,1)=visc/2*matrcoeffy.*((absky+absmy).*Vhoppy(:,:,1)+(absky.*by+absmy.*by).*Vhoppy(:,:,2)+(absky.*ky+absmy.*my).*Vhoppy(:,:,3));
matrjumpy(:,:,2)=visc/2*matrcoeffy.*((absky.*by+absmy.*by).*Vhoppy(:,:,1)+(absky.*by.^2+absmy.*by.^2+absly.*ny.^2).*Vhoppy(:,:,2)+(absky.*ky.*by+absmy.*my.*by).*Vhoppy(:,:,3));
matrjumpy(:,:,3)=visc/2*matrcoeffy.*((absky.*ky+absmy.*my).*Vhoppy(:,:,1)+(absky.*ky.*by+absmy.*my.*by).*Vhoppy(:,:,2)+(absky.*ky.^2+absmy.*my.^2).*Vhoppy(:,:,3));


ret1F(:,:,1)=((gamma-1).*firstx./(gamma*secondx))*0.5.*(wx(u0x)+wx(u1x))-matrjumpx(:,:,1);%-Matr(:,1);%-visc*dx/(2*dt).*(rho1-rho0);%%-visc.*(u(2:(end),1)-u(1:(end-1),1))%-visc.*D/(2).*Vhopp(:,1)%-visc*dx/(2*dt).*(u1(:,1)-u0(:,1));
ret1F(:,:,2)=((gamma-1).*firstx./(gamma*secondx)).*(0.5*(wx(u0x)+wx(u1x))).^2+kappa.*(0.5*(u0x(:,:,1).^gamma+u1x(:,:,1).^gamma))-matrjumpx(:,:,2);%-Matr(:,2);%-visc*dx/(2*dt).*(m1-m0);%-visc.*(u(2:(end),2)-u(1:(end-1),2))%-visc*D/(2).*Vhopp(:,2)%-visc*dx/(2*dt).*(u1(:,2)-u0(:,2));
ret1F(:,:,3)=((gamma-1).*firstx./(gamma*secondx))*0.25.*(wx(u0x)+wx(u1x)).*(wy(u0x)+wy(u0x))-matrjumpx(:,:,3);
ret1F=ret1F(2:end,:,:)-ret1F(1:end-1,:,:);
ret1G(:,:,1)=((gamma-1).*firsty./(gamma*secondy))*0.5.*(wy(u0y)+wy(u1y))-matrjumpy(:,:,1);%-Matr(:,1);%-visc*dx/(2*dt).*(rho1-rho0);%%-visc.*(u(2:(end),1)-u(1:(end-1),1))%-visc.*D/(2).*Vhopp(:,1)%-visc*dx/(2*dt).*(u1(:,1)-u0(:,1));
ret1G(:,:,2)=((gamma-1).*firsty./(gamma*secondy))*0.25.*(wx(u0y)+wx(u1y)).*(wy(u0y)+wy(u1y))-matrjumpy(:,:,2);%-Matr(:,2);%-visc*dx/(2*dt).*(m1-m0);%-visc.*(u(2:(end),2)-u(1:(end-1),2))%-visc*D/(2).*Vhopp(:,2)%-visc*dx/(2*dt).*(u1(:,2)-u0(:,2));
ret1G(:,:,3)=((gamma-1).*firsty./(gamma*secondy)).*(0.5*(wy(u0y)+wy(u1y))).^2+kappa.*(0.5*(u0y(:,:,1).^gamma+u1y(:,:,1).^gamma))-matrjumpy(:,:,3);
ret1G=ret1G(:,2:end,:)-ret1G(:,1:end-1,:);

end
 
function ret2 = f(u,kappa,gamma)
ret2(:,:,1) = u(:,:,2);
ret2(:,:,2) = u(:,:,2).^2./u(:,:,1)+kappa*u(:,:,1).^gamma;
ret2(:,:,3) = u(:,:,2).*u(:,:,3)./u(:,:,1);
end

function ret2b = g(u,kappa,gamma)
ret2b(:,:,1) = u(:,:,3);
ret2b(:,:,2) = u(:,:,2).*u(:,:,3)./u(:,:,1);
ret2b(:,:,3) = u(:,:,3).^2./u(:,:,1)+kappa*u(:,:,1).^gamma;
end

function ret= v(u,kappa,gamma)
ret(:,:,1)=kappa*gamma/(gamma-1).*u(:,:,1).^(gamma-1)-0.5.*wx(u).^2-0.5.*wy(u).^2;
ret(:,:,2)=wx(u);
ret(:,:,3)=wy(u);
end

function ret2b = locallaxfriedrich(u,kappa,gamma,dt,dx)
	c = mdf(u,kappa,gamma);
	D = max(c(1:end-1), c(2:end));
	D = [D, D];
	F = (f(u(2:end,:),kappa,gamma) + f(u(1:end-1,:),kappa,gamma))/2 - D/2.*(u(2:end,:) - u(1:end-1,:));
	ret2b = diff(F,1);
end

function ret2c = laxfriedrich(u,kappa,gamma,dt,dx,visc)
F1=(f(u(2:end-1,:),kappa,gamma)+f(u(1:end-2,:),kappa,gamma))/2-visc*dx/(2*dt)*(u(2:end-1,:)-u(1:end-2,:));
F2=(f(u(3:end,:),kappa,gamma)+f(u(2:end-1,:),kappa,gamma))/2-visc*dx/(2*dt)*(u(3:end,:)-u(2:end-1,:));
F=F2-F1;
ret2c(:,1) = F(:,1);
ret2c(:,2) = F(:,2);
end

function ret3 = mdf(u,kappa,gamma)
%ret3(:,1) = abs(w(u))+sqrt(g*u(:,1));
% sq=sqrt(gamma*kappa*u(:,1).^(gamma-1));
% vel1=max(abs(w(u)+sq));
% vel2=max(abs(w(u)-sq));
% ret3=max(vel1,vel2);
ret3 = abs(u(:,2)./u(:,1)) + sqrt(u(:,1));
end

function ret4 = w(u)
ret4=u(:,2)./u(:,1);
end

function ret4 = wx(u)
ret4=u(:,:,2)./u(:,:,1);
end

function ret4b =wy(u)
ret4b=u(:,:,3)./u(:,:,1);
end

function ret=avg(u0,u1)
ret=(u0+u1)/2;
end
