function U=Master2DuDiff(casenr,dx,t_end,visc,methnr)
%x=[0:dx:10];
%y=[0:dx:10];
[x,y]=meshgrid(0:dx:10)
kappa=1.5;
alpha=3
l=alpha+2
gamma=l/alpha
if gamma<=1
    return
end

switch casenr
    case {1}
        U(:,:,1) = 1+(1 + sin((2*x-pi/2))).*(1 + sin((2*y-pi/2))).*(x<=2*pi).*(x>=pi).*(y<=2*pi).*(y>=pi);
    case {2}
        U(:,:,1) = 1+ 0.5*ones(size(x)).*ones(size(y)).*(abs(x)<=7).*(abs(x)>=3).*(abs(y)<=5.5).*(abs(y)>=4.5);
    case {3}
        U(:,1) = 1+0.3*sin(x);
    case {4}
        U(:,1) = 0.6+ 0.2*heaviside(x-4);
    case {5}
        U(:,1) = 1+ 1*heaviside(4-x);
end

U(:,:,2)=zeros(size(x))
U(:,:,3)=zeros(size(x));
size(U)
Up=U;
Upt=U
t=0;
CFL=0.1;
N=size(U(:,1))
while t<t_end    
    dt =CFL*dx/max(mdf(U,kappa,gamma)); %tempdt
    %Corners
    Up(1,1,:)=(U(2,2,:));
    Up(end,end,:)=(U(end-1,end-1,:));
    Up(1,end,:)=(U(2,end-1,:));
    Up(end,1,:)=(U(end-1,2,:));
    %Sides
    Up(1,2:end-1,:)=(U(2,2:end-1,:));
    Up(end,2:end-1,:)=(U(end-1,2:end-1,:));
    Up(2:end-1,end,:)=(U(2:end-1,end-1,:));
    Up(2:end-1,1,:)=(U(2:end-1,2,:));

    switch methnr
        case {1}
            Fl=roesx(U,dt,dx,visc,kappa,gamma,l,alpha);
            Gl=roesy(U,dt,dx,visc,kappa,gamma,l,alpha);
            Up(2:(end-1),:,:)=U(2:(end-1),:,:)-dt/(dx).*Fl(1:end,:,:);
            Up(:,2:(end-1),:)=Up(:,2:(end-1),:)-dt/(dx).*Gl(:,1:end,:);

        case {2}
            Fl=locallaxfriedrich(U,kappa,gamma,dt,dx);
            Up(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*Fl(:,1);
            Up(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*Fl(:,2);   
        case {3}
            [Fl Gl]=fluxm(U,dt,dx,visc,kappa,gamma,l,alpha);
            Up(:,2:(end-1),:)=U(:,2:(end-1),:)-dt/(dx).*Gl(:,1:end,:);
            Up(2:(end-1),:,:)=Up(2:(end-1),:,:)-dt/(dx).*Fl(1:end,:,:);

        case {4}
            Fl=laxfriedrich(U,kappa,gamma,dt,dx,visc);
            Up(2:(end-1),1)=U(2:(end-1),1)-dt/(dx).*Fl(:,1);
            Up(2:(end-1),2)=U(2:(end-1),2)-dt/(dx).*Fl(:,2);   
        case {5}
            [Fl Gl]=fluxm(U,dt,dx,visc,kappa,gamma,l,alpha);
            Upt(2:(end-1),:,:)=U(2:(end-1),:,:)-dt/(dx).*Fl(1:end,:,:);
            Upt(:,2:(end-1),:)=Upt(:,2:(end-1),:)-dt/(dx).*Gl(:,1:end,:);
            [Fl2 Gl2]=fluxm(Upt,dt,dx,visc,kappa,gamma,l,alpha);
            Up(2:(end-1),:,:)=U(2:(end-1),:,:)-dt/(dx).*0.5*(Fl(1:end,:,:)+Fl2(1:end,:,:));
            Up(:,2:(end-1),:)=Up(:,2:(end-1),:)-dt/(dx).*0.5*(Gl(:,1:end,:)+Gl2(:,1:end,:));
    end
    U=Up;
    lowerH=0.1;
    [L M]=size(U(:,:,1));
    for i=2:L-1
        for j=2:M-1
            if U(i,j,1)<lowerH
                U(i,j,1)=lowerH
                U(i,i,2)=0;
                U(i,i,3)=0;
            end
        end
    end        
    surf(x,y,U(:,:,1))
    %axis([-2 16 -2 5]);
    shg
    drawnow;
    %pause(1/10)
    
    t=t+dt;
end
%axis([-2 16 -2 2]);
%shg
%plot(x,U,'-');
surf(x,y,U(:,:,1))

end

function ret1 = roesx(u,dt,dx,visc,kappa,gamma,l,alpha)
u1(:,:,:)=u(1:end-1,:,:);
u0(:,:,:)=u(2:end,:,:);
favg=0.5*(f(u1,kappa,gamma) + f(u0,kappa,gamma));
ret1(:,:,1)=favg(:,:,1);%-Matr(:,1);%-visc*dx/(2*dt).*(rho1-rho0);%%-visc.*(u(2:(end),1)-u(1:(end-1),1))%-visc.*D/(2).*Vhopp(:,1)%-visc*dx/(2*dt).*(u1(:,1)-u0(:,1));
ret1(:,:,2)=favg(:,:,2);%-Matr(:,2);%-visc*dx/(2*dt).*(m1-m0);%-visc.*(u(2:(end),2)-u(1:(end-1),2))%-visc*D/(2).*Vhopp(:,2)%-visc*dx/(2*dt).*(u1(:,2)-u0(:,2));
ret1(:,:,3)=favg(:,:,3);
ret1=ret1(2:end,:,:)-ret1(1:end-1,:,:);
end

function ret1b = roesy(u,dt,dx,visc,kappa,gamma,l,alpha)
u1(:,:,:)=u(:,1:end-1,:);
u0(:,:,:)=u(:,2:end,:);
gavg=0.5*(g(u1,kappa,gamma) + g(u0,kappa,gamma));
ret1b(:,:,1)=gavg(:,:,1);%-Matr(:,1);%-visc*dx/(2*dt).*(rho1-rho0);%%-visc.*(u(2:(end),1)-u(1:(end-1),1))%-visc.*D/(2).*Vhopp(:,1)%-visc*dx/(2*dt).*(u1(:,1)-u0(:,1));
ret1b(:,:,2)=gavg(:,:,2);%-Matr(:,2);%-visc*dx/(2*dt).*(m1-m0);%-visc.*(u(2:(end),2)-u(1:(end-1),2))%-visc*D/(2).*Vhopp(:,2)%-visc*dx/(2*dt).*(u1(:,2)-u0(:,2));
ret1b(:,:,3)=gavg(:,:,3);
ret1b=ret1b(:,2:end,:)-ret1b(:,1:end-1,:);
end

function [ret1F ret1G] = fluxm(u,dt,dx,~,kappa,gamma,l,alpha)
u0x(:,:,:)=u(1:end-1,:,:);
u1x(:,:,:)=u(2:end,:,:);
u0y(:,:,:)=u(:,1:end-1,:);
u1y(:,:,:)=u(:,2:end,:);

firstx=(u1x(:,:,1).^(1/alpha)+u0x(:,:,1).^(1/alpha));
firsty=(u1y(:,:,1).^(1/alpha)+u0y(:,:,1).^(1/alpha));
if l-1>=2
    for i=2:l-1
        firstx=firstx.*avg(u0x(:,:,1).^(1/alpha),u1x(:,:,1).^(1/alpha))+avg(u0x(:,:,1).^(i/alpha),u1x(:,:,1).^(i/alpha));
        firsty=firsty.*avg(u0y(:,:,1).^(1/alpha),u1y(:,:,1).^(1/alpha))+avg(u0y(:,:,1).^(i/alpha),u1y(:,:,1).^(i/alpha));
    end
end
secondx=(u0x(:,:,1).^(1/alpha)+u1x(:,:,1).^(1/alpha));
secondy=(u0y(:,:,1).^(1/alpha)+u1y(:,:,1).^(1/alpha));
%Vhopp=v2(rho1,m1,kappa,gamma)-v2(rho0,m0,kappa,gamma);
%Vhopp=Vhopp.';
%ups=(gamma*kappa*0.5.*(rho0.^(gamma-1)+rho1(:,1).^(gamma-1))).^0.5;
%Rx(1,1,:)=ones(length(u(:,:,1)));
%Rx(1,2,:)=zeros(length(u(:,:,1)));
%Rx(1,3,:)=ones(length(u(:,:,1)));
%Rx(2,1,:)=(u0(:,:,1).^(0.5).*wx(u0)+u1(:,:,1).^(0.5).*wx(u1))./(rho0.^(0.5)+rho1.^(0.5))-ups;
%Rx(2,2,:)=zeros(length(u(:,:,1)));
%Rx(2,3,:)=(rho0.^(0.5).*wx(rho0,m0)+rho1.^(0.5).*wx(rho1,m1))./(rho0.^(0.5)+rho1.^(0.5))+ups;
%Rx(3,1,:)=wy
%Rx(3,2,:)=(2*ups).^0.5
%Rx(3,3,:)=wy
%RT(1,1,:)=ones(size(rho0));
%RT(1,2,:)=(rho0.^(0.5).*w2(rho0,m0)+rho1.^(0.5).*w2(rho1,m1))./(rho0.^(0.5)+rho1.^(0.5))-(gamma*kappa*0.5.*(rho0.^(gamma-1)+rho1.^(gamma-1))).^0.5;
%RT(2,1,:)=ones(size(rho0));
%RT(2,2,:)=(rho0.^(0.5).*w2(rho0,m0)+rho1.^(0.5).*w2(rho1,m1))./(rho0.^(0.5)+rho1.^(0.5))+(gamma*kappa*0.5.*(rho0.^(gamma-1)+rho1.^(gamma-1))).^0.5;

%for i=1:size(rho0)
%R(1:2,1:2,i)=R(1:2,1:2,i).*(0.5.*(rho0(i,1)+rho1(i,1))/(2*kappa*gamma)).^0.5;
%RT(1:2,1:2,i)=RT(1:2,1:2,i).*(0.5.*(rho0(i,1)+rho1(i,1))/(2*kappa*gamma)).^0.5;
%end

%LambdaC(1,1,:)=abs((rho0.^(0.5).*w2(rho0,m0)+rho1.^(0.5).*w2(rho1,m1))./(rho0.^(0.5)+rho1.^(0.5))-(gamma*kappa*0.5.*(rho0.^(gamma-1)+rho1(:,1).^(gamma-1))).^0.5);
%LambdaC(1,2,:)=zeros(size(rho0));
%LambdaC(2,1,:)=zeros(size(rho0));
%LambdaC(2,2,:)=abs((rho0.^(0.5).*w2(rho0,m0)+rho1.^(0.5).*w2(rho1,m1))./(rho0.^(0.5)+rho1.^(0.5))+(gamma*kappa*0.5.*(rho0.^(gamma-1)+rho1(:,1).^(gamma-1))).^0.5);
%size(R);
%size(RT);
%size(LambdaC);
%size(Vhopp);
%for i=1:size(rho0)
%    Matr(:,i)=visc/2*(R(:,:,i)*LambdaC(:,:,i)*RT(:,:,i))*Vhopp(:,i);
%end
%Matr=Matr.';
%	c = mdf(u,kappa,gamma);
%	D = max(c(1:end-1), c(2:end));
%	D = [D, D];
%Diffu2=D/2.*([rho1 m1] - [rho0 m0]);
ret1F(:,:,1)=((gamma-1).*firstx./(gamma*secondx))*0.5.*(wx(u0x)+wx(u1x));%-Matr(:,1);%-visc*dx/(2*dt).*(rho1-rho0);%%-visc.*(u(2:(end),1)-u(1:(end-1),1))%-visc.*D/(2).*Vhopp(:,1)%-visc*dx/(2*dt).*(u1(:,1)-u0(:,1));
ret1F(:,:,2)=((gamma-1).*firstx./(gamma*secondx)).*(0.5*(wx(u0x)+wx(u1x))).^2+kappa.*(0.5*(u0x(:,:,1).^gamma+u1x(:,:,1).^gamma));%-Matr(:,2);%-visc*dx/(2*dt).*(m1-m0);%-visc.*(u(2:(end),2)-u(1:(end-1),2))%-visc*D/(2).*Vhopp(:,2)%-visc*dx/(2*dt).*(u1(:,2)-u0(:,2));
ret1F(:,:,3)=((gamma-1).*firstx./(gamma*secondx))*0.25.*(wx(u0x)+wx(u1x)).*(wy(u0x)+wy(u0x));
ret1F=ret1F(2:end,:,:)-ret1F(1:end-1,:,:);
ret1G(:,:,1)=((gamma-1).*firsty./(gamma*secondy))*0.5.*(wy(u0y)+wy(u1y));%-Matr(:,1);%-visc*dx/(2*dt).*(rho1-rho0);%%-visc.*(u(2:(end),1)-u(1:(end-1),1))%-visc.*D/(2).*Vhopp(:,1)%-visc*dx/(2*dt).*(u1(:,1)-u0(:,1));
ret1G(:,:,2)=((gamma-1).*firsty./(gamma*secondy))*0.25.*(wx(u0y)+wx(u1y)).*(wy(u0y)+wy(u1y));%-Matr(:,2);%-visc*dx/(2*dt).*(m1-m0);%-visc.*(u(2:(end),2)-u(1:(end-1),2))%-visc*D/(2).*Vhopp(:,2)%-visc*dx/(2*dt).*(u1(:,2)-u0(:,2));
ret1G(:,:,3)=((gamma-1).*firsty./(gamma*secondy)).*(0.5*(wy(u0y)+wy(u1y))).^2+kappa.*(0.5*(u0y(:,:,1).^gamma+u1y(:,:,1).^gamma));
ret1G=ret1G(:,2:end,:)-ret1G(:,1:end-1,:);

end
 
function ret2 = f(u,kappa,gamma)
ret2(:,:,1) = u(:,:,2);
ret2(:,:,2) = u(:,:,2).^2./u(:,:,1)+kappa*u(:,:,1).^gamma;
ret2(:,:,3) = u(:,:,2).*u(:,:,3)./u(:,:,1);
end

function ret2b = g(u,kappa,gamma)
ret2b(:,:,1) = u(:,:,3);
ret2b(:,:,2) = u(:,:,2).*u(:,:,3)./u(:,:,1);
ret2b(:,:,3) = u(:,:,3).^2./u(:,:,1)+kappa*u(:,:,1).^gamma;
end

function ret= v(u,kappa,gamma)
ret(:,1)=kappa*gamma/(gamma-1).*u(:,1).^(gamma-1)-0.5.*w(u).^2;
ret(:,2)=w(u);
end

function ret= v2(rho,m,kappa,gamma)
ret(:,1)=kappa*gamma/(gamma-1).*rho.^(gamma-1)-0.5.*w2(rho,m).^2;
ret(:,2)=w2(rho,m);
end

function ret2b = locallaxfriedrich(u,kappa,gamma,dt,dx)
	c = mdf(u,kappa,gamma);
	D = max(c(1:end-1), c(2:end));
	D = [D, D];
	F = (f(u(2:end,:),kappa,gamma) + f(u(1:end-1,:),kappa,gamma))/2 - D/2.*(u(2:end,:) - u(1:end-1,:));
	ret2b = diff(F,1);
end

function ret2c = laxfriedrich(u,kappa,gamma,dt,dx,visc)
F1=(f(u(2:end-1,:),kappa,gamma)+f(u(1:end-2,:),kappa,gamma))/2-visc*dx/(2*dt)*(u(2:end-1,:)-u(1:end-2,:));
F2=(f(u(3:end,:),kappa,gamma)+f(u(2:end-1,:),kappa,gamma))/2-visc*dx/(2*dt)*(u(3:end,:)-u(2:end-1,:));
F=F2-F1;
ret2c(:,1) = F(:,1);
ret2c(:,2) = F(:,2);
end

function ret3 = mdf(u,kappa,gamma)
%ret3(:,1) = abs(w(u))+sqrt(g*u(:,1));
% sq=sqrt(gamma*kappa*u(:,1).^(gamma-1));
% vel1=max(abs(w(u)+sq));
% vel2=max(abs(w(u)-sq));
% ret3=max(vel1,vel2);
ret3 = abs(u(:,2)./u(:,1)) + sqrt(u(:,1));
end

function ret4 = w(u)
ret4=u(:,2)./u(:,1);
end

function ret4 = wx(u)
ret4=u(:,:,2)./u(:,:,1);
end

function ret4b =wy(u)
ret4b=u(:,:,3)./u(:,:,1);
end

function ret=avg(u0,u1)
ret=(u0+u1)/2;
end

